<?php
/*
 * Function requested by Ajax
 */

if(isset($_POST['func']) && !empty($_POST['func'])){
    switch($_POST['func']){
        case 'getCalendar':
            getCalender($_POST['year'],$_POST['month']);
            break;
        case 'getEvents':
            getEvents($_POST['date']);
            break;
        default:
            break;
    }
}

/*
 * Get calendar full HTML
 */
function getCalender($year = '',$month = '')
{
    $dateYear = ($year != '')?$year:date("Y");
    $dateMonth = ($month != '')?$month:date("m");
    $date = $dateYear.'-'.$dateMonth.'-01';
    $currentMonthFirstDay = date("N",strtotime($date));
    $totalDaysOfMonth = cal_days_in_month(CAL_GREGORIAN,$dateMonth,$dateYear);
    $totalDaysOfMonthDisplay = ($currentMonthFirstDay == 7)?($totalDaysOfMonth):($totalDaysOfMonth + $currentMonthFirstDay);
    $boxDisplay = ($totalDaysOfMonthDisplay <= 35)?35:42;
?>
    <div id="calender_section">
        <h2><strong>
            <a href="javascript:void(0);" onClick="getCalender('calendar_div','<?php echo date("Y",strtotime($date.' - 1 Month')); ?>','<?php echo date("m",strtotime($date.' - 1 Month')); ?>');">&lt;&lt;</a>
            <select name="month_dropdown" class="month_dropdown dropdown"><?php echo getAllMonths($dateMonth); ?></select>
            <select name="year_dropdown" class="year_dropdown dropdown"><?php echo getYearList($dateYear); ?></select>
            <a href="javascript:void(0);" onClick="getCalender('calendar_div','<?php echo date("Y",strtotime($date.' + 1 Month')); ?>','<?php echo date("m",strtotime($date.' + 1 Month')); ?>');">&gt;&gt;</a>
        </strong></h2>
        <div id="event_list" class="none"></div>
        <div id="calender_section_top">
            <h2><strong> CALENDARIO MENSUAL </strong></h2>
            <ul>
                <li>Domingo</li>
                <li>Lunes</li>
                <li>Martes</li>
                <li>Miércoles</li>
                <li>Juevez</li>
                <li>Viernes</li>
                <li>Sábado</li>
            </ul>
        </div>
        <div id="calender_section_bot">
            <ul>
            <?php 
                $dayCount = 1; 
                for($cb=1;$cb<=$boxDisplay;$cb++){
                    if(($cb >= $currentMonthFirstDay+1 || $currentMonthFirstDay == 7) && $cb <= ($totalDaysOfMonthDisplay)){
                        //Current date
                        $currentDate = $dateYear.'-'.$dateMonth.'-'.$dayCount;
                        $eventNum = 0;
                        //Include db configuration file
                        include 'DBConfig.php';
                        //Get number of events based on the current date
                        $result = $db->query("SELECT title FROM event WHERE date_at = '$currentDate' ");
                        $eventNum = $result->num_rows;
                        //Define date cell color
                        if(strtotime($currentDate) == strtotime(date("Y-m-d"))){
                            echo '<li date="'.$currentDate.'" class="grey date_cell">';
                        }elseif($eventNum > 0){
                            echo '<li date="'.$currentDate.'" class="light_sky date_cell">';
                        }else{
                            echo '<li date="'.$currentDate.'" class="date_cell">';
                        }
                        //Date cell
                        
                        echo '<span>';
                        echo $dayCount;
                        echo '</span>';
                        
                        //Hover event popup
                        
                        echo '<div id="date_popup_'.$currentDate.'" class="date_popup_wrap none">';
                        echo '<div class="date_window">';
                        echo '<div class="popup_event">Eventos ('.$eventNum.')</div>';
                        echo ($eventNum > 0)?'<a href="javascript:;" onClick="getEvents(\''.$currentDate.'\');">Ver </a>':'';
                        echo '</div></div>';
                        
                        echo '</li>'; 
                        $dayCount++; 
            ?>
            <?php }else{ ?>
                <li><span>&nbsp;</span></li>
            <?php } } ?>
            </ul>
        </div>
    </div>

    <script type="text/javascript">
        function getCalender(target_div,year,month){
            $.ajax({
                type:'POST',
                url:'core/functions.php',
                data:'func=getCalendar&year='+year+'&month='+month,
                success:function(html){
                    $('#'+target_div).html(html);
                }
            });
        }
        
        function getEvents(date){
            $.ajax({
                type:'POST',
                url:'core/functions.php',
                data:'func=getEvents&date='+date,
                success:function(html){
                    $('#event_list').html(html);
                    $('#event_list').slideDown('slow');
                }
            });
        }
        
        function addEvent(date){
            $.ajax({
                type:'POST',
                url:'core/functions.php',
                data:'func=addEvent&date='+date,
                success:function(html){
                    $('#event_list').html(html);
                    $('#event_list').slideDown('slow');
                }
            });
        }
        
        $(document).ready(function(){
            $('.date_cell').mouseenter(function(){
                date = $(this).attr('date');
                $(".date_popup_wrap").fadeOut();
                $("#date_popup_"+date).fadeIn();    
            });
            $('.date_cell').mouseleave(function(){
                $(".date_popup_wrap").fadeOut();        
            });
            $('.month_dropdown').on('change',function(){
                getCalender('calendar_div',$('.year_dropdown').val(),$('.month_dropdown').val());
            });
            $('.year_dropdown').on('change',function(){
                getCalender('calendar_div',$('.year_dropdown').val(),$('.month_dropdown').val());
            });
            $(document).click(function(){
                $('#event_list').slideUp('slow');
            });
        });
    </script>
<?php
}

/*
 * Get months options list.
 */
function getAllMonths($selected = ''){
    $options = '';
    for($i=1;$i<=12;$i++)
    {
        $value = ($i < 10)?'0'.$i:$i;
        $selectedOpt = ($value == $selected)?'selected':'';
        $options .= '<option value="'.$value.'" '.$selectedOpt.' >'.date("F", mktime(0, 0, 0, $i+1, 0, 0)).'</option>';
    }
    return $options;
}

/*
 * Get years options list.
 */
function getYearList($selected = ''){
    $options = '';
    for($i=2016;$i<=2050;$i++)
    {
        $selectedOpt = ($i == $selected)?'selected':'';
        $options .= '<option value="'.$i.'" '.$selectedOpt.' >'.$i.'</option>';
    }
    return $options;
}

/*
 * Get events by date
 */
function getEvents($date = ''){
    //Include db configuration file
    include 'dbConfig.php';
    $eventListHTML = '';
    $date = $date?$date:date("Y-m-d");
    //Get events based on the current date
    //$result = $db->query("SELECT title FROM event WHERE date_at = '$date' "); //'".$date."' ");
    $result = $db->query("Select 
s.name sala, concat(c.name,' ',c.lastname) as nombres, e.title, e.time_at f_ini, e.time_fn f_fin 
from  event e 
inner join contact c 
on e.contact_id = c.id 
left join salas s 
on s.id = e.sala_id 
where e.date_at = '$date' 
order by 1");
    if($result->num_rows > 0){
        $eventListHTML = '<h2>Eventos del día '.date("l, d M Y",strtotime($date)).'</h2>';
        //$eventListHTML .= '<ul>';
        $eventListHTML .= '<table class="table table-bordered table-hover">
        <thead>
        <th>SALA</th>
        <th>ORGANIZADOR</th>
        <th>EVENTO</th>
        <th>INICIO</th>
        <th>FIN</th>
        </thead>';
        while($row = $result->fetch_assoc()){ 
            //$eventListHTML .= '<li>'.$row['hora'].'</li>';
            //$eventListHTML .= '<li>'.$row['sala_1'].'</li>';
            //$eventListHTML .= '<li>'.$row['sala_2'].'</li>';
            $eventListHTML .= '<tr><td>'.$row['sala'].'</td><td>'.$row['nombres'].'</td><td>'.$row['title'].'</td>
            <td>'.$row['f_ini'].'</td><td>'.$row['f_fin'].'</td></tr>';
        }
        //$eventListHTML .= '</ul>';
    }
    echo $eventListHTML;
}
?>